<script>
  import {onMount} from "svelte";
  import {json} from "d3-fetch";
  import {extent} from "d3-array";
  import { scaleLinear } from "d3-scale";
  import { day_width, leaf_hwidth, leaf_length, xScale_l, xScale_r, yScale_e, yScale_g} from "./store_3";
  import Leaf_right from "./_design_3_leaf_right.svelte";
  import Leaf_left from "./_design_3_leaf_left.svelte";



  let datapoints = [];
onMount(async () => {
  datapoints = await json('/data/hourly_electricity_vs_gas_december.json')
});

//$: console.log(datapoints)

let transformed_data = {}
$: {datapoints.forEach((d)=>{
  if(!(d.week in transformed_data)){
    transformed_data[d.week]={}
  }
  if(!(d.day in transformed_data[d.week])){
    transformed_data[d.week][d.day]={"electricity":[],"gas":[],"date":d.day}
    
  }
  if(!(d.hour in transformed_data[d.week][d.day])){
    transformed_data[d.week][d.day]["electricity"].push(d.total_electrity)
    transformed_data[d.week][d.day]["gas"].push(d.total_gas)
  }
  
}
  
  )}

  //$: console.log(transformed_data)

  // Size and margins
  const width = 500;
  const height = 650;
  const margin = { top: 10, right: 10, bottom: 50, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

 

  
 
 //$: console.log(extent(datapoints.map((d)=>d.total_electrity)))
 //$: console.log(extent(datapoints.map((d)=>d.total_gas)))
</script>


<svg {width} {height}>
  <g transform="translate({margin.left}, {margin.top})">
    <text id="title" x=0 y=15>Baltimore December 2014</text>
    <text x=0 y=40>Gas and electricity usage</text>
    <text x=0 y=60>in 5 weeks</text>
    <rect class="electricity" x=0 y=600 width=15 height=10/>
    <rect class="gas" x=0 y=620 width=15 height=10/>
    <text x=20 y=610>electricity usage</text>
    <text x=20 y=630>gas usage</text>
    <line x1={innerWidth/2} x2={innerWidth/2} y1={innerHeight+40} y2=50 />
  {#each Object.keys(transformed_data) as week_nr, week_idx}
  <g transform="translate({innerWidth/2},{innerHeight-100*(week_idx+1)})" >
    {#if week_idx%2==0}
    <line class="branch" x1=0 x2={leaf_length} y1={yScale_e(0)} y2={yScale_e(0)}/>
    {#each Object.keys(transformed_data[week_nr]) as day_nr, day_idx}
    <g class="rightleaf" transform="translate({(day_idx)*day_width},0)">
      <Leaf_right data = {transformed_data[week_nr][day_nr]}/>
    </g>
    
    {/each}
    {:else}
    <line class="branch" x1={-leaf_length} x2=0 y1={yScale_g(0)} y2={yScale_g(0)}/>
    {#each Object.keys(transformed_data[week_nr]) as day_nr, day_idx}
    <g class="leftleaf" transform="translate({(-day_idx)*day_width},0)">
      <Leaf_left data = {transformed_data[week_nr][day_nr]}/>
    </g>
    {/each}
  
  
    {/if}

    
  </g>
  {/each}


  

  </g>
</svg>

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
  line {
    stroke: black;
    stroke-width: 3px;
  }
  #title {
    stroke: black;
    font-size: 20px;
  }
  .electricity {
    fill:skyblue;
  }
  .gas {
    fill: orange;
  }
  
</style>
